#!/usr/local/bin/perl
#
# ＵＴＦ８の日本語ファイル削除用ＣＧＩ

# ----------------------------------------------------------------------
# 設定用変数

use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;
use Encode qw/ from_to /;

$ENV{'TZ'} = "JST-9"; 

# 漢字コード
$kanji_code = "utf8";

# ＣＧＩの名前
$cgi_name = '/cgi-bin/_del.cgi';

# 処理モード
$mode = $ENV{'QUERY_STRING'};

# 簡易パスワード
$pw = '';

# ----------------------------------------------------------------------
# 画面表示

$Html = <<'EOF';		
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="robots" content="noindex,nofollow,noarchive">
<title>File ment tool</title>
</head><body>
<form name="FormName" action="%%cgi%%" method="post">
<hr>
ファイル名称に、UTF8の日本語を使ったファイルを削除できます。
<hr>
パスワード：<input name="password" type="password" size="10"><br>
サイトパス：<input name="fullpath" type="text" size="60"><br>
ファイル名：<input name="filename" type="text" size="40">&nbsp;
ディレクトリ：<input name="isDir" type="checkbox"><br><br>
<font color="#ff0000">サイトパスは本CGIからの相対パスを指定（例：../hoge/fuga/）</font><br><br>
<input type="submit" name="submitButtonName" value="削除">&nbsp;<input type="reset" value="リセット">
<hr>
</form>
</body></html>

EOF


# ----------------------------------------------------------------------
# メイン

if ($mode eq '')	{
	# HTMLページ出力処理
	$Html =~ s/%%cgi%%/$cgi_name?del/g;
	print "Content-type: text/html\n\n";
	print $Html;
}
else	{
	&getinputfromweb($kanji_code);

	$password = $form{'password'};
	$fullpath = $form{'fullpath'};
	$filename = $form{'filename'};
	$delfile = $fullpath . $filename;
	$isDir = $form{'isDir'};

	if ($pw ne $password || $filename eq '' || $fullpath eq '')	{
		print "Content-type: text/html;charset=utf-8\n\n";
		print "<TITLE>入力エラー</TITLE>\n";
		print "パスワードが違うか、フルパス名、ファイル名が入力されていません。<BR>\n";
		print "<br><br>\n";
		print '<A onmouseover="',"status='戻る';return true;",'" onmouseout="',"status='';return true;",'" href="javaScript:history.back();">[戻る]</A>',"\n";
	}
	else	{

		$rinf = 0;
		$mode = '';

		# ファイル存在チェック
		if ($isDir eq 'on')	{
			# ディレクトリを指定
			$mode = 'ディレクトリ';
		}
		else	{
			# ファイルを指定
			$mode = 'ファイル';
		}
		if (-e $delfile)	{
			if ($isDir ne 'on')	{
				if (0 < unlink("$delfile"))	{
					$rinf = 0;
				}
				else	{
					$rinf = 1;
				}
			}
			else	{
				&rmAll($delfile);
				$rinf = 0;
			}
		}
		else	{
			$rinf = -1;
		}

		#&doDelete();
		print "Content-type: text/html;charset=utf-8\n\n";
		print "<TITLE>処理結果</TITLE>\n";
		print "$mode名 = '$delfile'　を受け付けました。<BR><BR>\n";
		if ($rinf == 0)	{
			print "対象の$modeの削除が完了しました。<BR>\n";
		}
		if ($rinf == -1)	{
			print "対象の$modeは存在しません。<BR>\n";
		}	
		if ($rinf == 1)	{
			print "対象$modeの削除が出来ませんでした。<BR>\n";
		}
		print "<br><br>\n";
		print '<A onmouseover="',"status='戻る';return true;",'" onmouseout="',"status='';return true;",'" href="javaScript:history.back();">[戻る]</A>',"\n";
	}

}


exit;



############################################################
# ＷＥＢから送信されたフォームを読み込む
# 引き数：jcode.plの文字コード(sjis,jis,euc,etc)
# 戻り値：フォームの配列(%FORM)
#
sub read_input
{
	$charset = $_[0];
	$charset = 'euc' if ( $charset eq '' );
	local ($buffer, @pairs, $pair, $envname, $value, %FORM);

	$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
	if ($ENV{'REQUEST_METHOD'} eq "POST"){
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}else{
		$buffer = $ENV{'QUERY_STRING'};
	}
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs){
		($envname, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\r\n/<BR>/g;
		$value =~ s/\n/<BR>/g;
		$value =~ s/\t/    /g;		
		#&jcode'convert(*value, $charset);
		 my $enc = guess_encoding ( $value );
		if ( ref $enc ) { from_to ( $value , $enc->name , $charset ); }

		$FORM{$envname} = $value;
	}
	%FORM;
}

############################################################
# ＷＥＢから送信されたフォームを読み込みメインルーチンへ渡す
# 引き数：jcode.plの文字コード(sjis,jis,euc,etc)
# 戻り値：フォームの配列(form{'name'})
#
sub getinputfromweb {
	%main'form = &read_input( @_ );
}

############################################################
#ディレクトリ配下を全て削除（指定ディレクトリ含む）
# 引数：ディレクトリのパス：スカラー
# 戻り値：なし
sub rmAll{
    my $dir = shift;
    my $file;
    opendir(DIR, $dir) or die("Can not open directory:$dir ($!)");
    while( $file = readdir(DIR) ){
        next if( $file =~ /^\.{1,2}$/ );        # '.' と '..' はパス

        #-- ディレクトリの場合は自分自身を呼び出す --#
        if( -d "$dir/$file" ){
            rmAll("$dir/$file");
        }
        #-- それ以外は unlink --#
        else{
            unlink("$dir/$file") or die("Can not unlink file:$dir/$file ($!)");
        }
    }
    closedir(DIR);
    #-- 最後に指定ディレクトリを削除 --#
    rmdir($dir) or die("Can not open directory:$dir ($!)");
}